'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**************************************************
 * Created by nanyuantingfeng on 16/08/2017 13:10.
 **************************************************/
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var cwd, devtool, rules, ENV, packageMap, outputPath, publicPath, hash, output, _context$unknownConte, unknownContextCritical, jsChunkFileName, webpackConfig;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.output = {};
            context.webpackConfig = {
              optimization: {}
            };

            next();

            cwd = context.cwd, devtool = context.devtool, rules = context.rules, ENV = context.ENV, packageMap = context.packageMap, outputPath = context.outputPath, publicPath = context.publicPath, hash = context.hash, output = context.output, _context$unknownConte = context.unknownContextCritical, unknownContextCritical = _context$unknownConte === undefined ? false : _context$unknownConte;
            jsChunkFileName = hash ? '[name]-[chunkhash].js' : '[name].js';
            webpackConfig = context.webpackConfig = (0, _extends3.default)({

              cache: true,

              entry: context.entry || packageMap.entry,

              resolve: {
                modules: ['node_modules', _path2.default.join(__dirname, '../node_modules')],
                extensions: ['.web.tsx', '.web.ts', '.web.jsx', '.web.js', '.ts', '.tsx', '.js', '.jsx', '.json', '.lazy.js', '.lazy.jsx', '.worker.js', '.worker.ts']
              },

              output: (0, _extends3.default)({
                filename: jsChunkFileName,
                chunkFilename: jsChunkFileName
              }, output),

              context: context.context || cwd,

              externals: context.externals,

              node: (0, _util.fnGetNode)(packageMap),

              devtool: (0, _util.fnBuildSourceMap)(devtool, ENV),

              module: {
                noParse: [/moment.js/],
                rules: rules,
                unknownContextCritical: unknownContextCritical
              },

              plugins: context.plugins

            }, context.webpackConfig);


            if (outputPath) {
              webpackConfig.output.path = _path2.default.join(cwd, outputPath);
            }

            if (publicPath) {
              webpackConfig.output.publicPath = publicPath;
            }

            (0, _util.fnCheckWebpackConfig)(webpackConfig);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];