'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _plugins = require('./plugins');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var hash, compress, plugins, dll, filename, chunkFilename;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.plugins = [new _plugins.FriendlyErrorsWebpackPlugin({
              onErrors: function onErrors(severity, errors) {
                if (severity !== 'error') {
                  _util.notifier.notify({
                    title: 'hollow cli',
                    message: 'warn',
                    contentImage: _path2.default.join(__dirname, '../assets/warn.png'),
                    sound: 'Glass'
                  });
                  return;
                }
                var error = errors[0];
                _util.notifier.notify({
                  title: 'hollow cli',
                  message: severity + ' : ' + (error ? error.name : error),
                  subtitle: error ? error.file : error || '',
                  contentImage: _path2.default.join(__dirname, '../assets/fail.png'),
                  sound: 'Glass'
                });
              }
            }), new _plugins.ProgressPlugin(_util.fnProgressHandler), new _plugins.HashedModuleIdsPlugin()];

            next();

            hash = context.hash, compress = context.compress, plugins = context.plugins, dll = context.dll;

            if (!Array.isArray(dll)) {
              context.webpackConfig.optimization.splitChunks = {
                chunks: 'async',
                minSize: 244 * 1024,
                minChunks: 1,
                maxAsyncRequests: 5,
                maxInitialRequests: 3,
                name: true,
                cacheGroups: {
                  default: {
                    minChunks: 2,
                    priority: -20,
                    reuseExistingChunk: true
                  },
                  vendors: {
                    test: /[/]node_modules[/]/,
                    priority: -10
                  }
                }
              };
            }

            filename = hash ? '[name]-[hash].css' : '[name].css';
            chunkFilename = hash ? '[id]-[hash].css' : '[id].css';


            plugins.push(new _plugins.MiniCssExtractPlugin({
              filename: filename,
              chunkFilename: chunkFilename
            }));

            context.webpackConfig.optimization.minimize = !!compress;

            // dll 模式下不能使用当前插件
            if (!Array.isArray(dll)) {
              plugins.push(new _plugins.AggressiveSplittingPlugin({
                minSize: 244 * 1024,
                maxSize: 800 * 1024,
                chunkOverhead: 0,
                entryChunkMultiplicator: 1
              }));
            }

            context.plugins = plugins;

            //context.webpackConfig.recordsOutputPath = path.join(cwd, 'build', 'records.json')

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}(); /**************************************************
      * Created by nanyuantingfeng on 27/10/2017 16:25.
      **************************************************/


module.exports = exports['default'];