'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _plugins = require('./plugins');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var THREAD_POOL_CPU_SIZE = _os2.default.cpus().length / 2; /**************************************************
                                                            * Created by nanyuantingfeng on 27/10/2017 16:28.
                                                            **************************************************/


function fnGetThemeMap(packageMap, cwd) {
  var theme = {};

  var packageMapTheme = packageMap.theme;

  if (packageMapTheme && typeof packageMapTheme === 'string') {

    var pp = packageMapTheme;

    if (pp.charAt(0) === '.') {
      pp = _path2.default.resolve(cwd, pp);
    }

    var fn = require(pp);
    theme = fn();
  } else if (packageMapTheme && (typeof packageMapTheme === 'undefined' ? 'undefined' : (0, _typeof3.default)(packageMapTheme)) === 'object') {
    theme = packageMapTheme;
  }

  return theme;
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var cwd, _context$limit, limit, ENV, packageMap, hash, plugins, theme, babelOptions, postcssOptions, tsOptions, tsConfigPath, rules, workerFileName, scriptRules, stylesRules, othersRules, styleRulesFixed, threadPool;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.rules = [];

            next();

            cwd = context.cwd, _context$limit = context.limit, limit = _context$limit === undefined ? 10000 : _context$limit, ENV = context.ENV, packageMap = context.packageMap, hash = context.hash, plugins = context.plugins;
            theme = fnGetThemeMap(packageMap, cwd);
            babelOptions = context.babelOptions, postcssOptions = context.postcssOptions, tsOptions = context.tsOptions, tsConfigPath = context.tsConfigPath, rules = context.rules;
            workerFileName = hash ? '[hash].worker.js' : '[name].worker.js';
            scriptRules = [{
              test: /\.worker\.jsx?$/,
              exclude: /node_modules/,
              use: [{ loader: 'worker-loader', options: { name: workerFileName } }, { loader: 'happypack/loader', options: { id: 'jsx' } }]
            }, {
              test: function test(filePath) {
                return (/\.lazy\.jsx?$/.test(filePath)
                );
              },

              exclude: /node_modules/,
              use: [{ loader: 'bundle-loader', options: { lazy: true } }, { loader: 'happypack/loader', options: { id: 'jsx' } }]
            }, {
              test: function test(filePath) {
                return (/\.jsx?$/.test(filePath) && !/\.lazy\.jsx?$/.test(filePath) && !/\.worker\.jsx?$/.test(filePath)
                );
              },

              exclude: /node_modules/,
              use: [{ loader: 'happypack/loader', options: { id: 'jsx' } }]
            }, {
              test: /\.tsx?$/,
              exclude: /node_modules/,
              use: [{ loader: 'happypack/loader', options: { id: 'tsx' } }]
            }];
            stylesRules = [{
              test: function test(filePath) {
                return (/\.css$/.test(filePath) && !/\.module\.css$/.test(filePath)
                );
              },

              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader', options: {
                  sourceMap: true,
                  minimize: !ENV.isDevelopment
                }
              }, { loader: 'postcss-loader', options: postcssOptions }]
            }, {
              test: /\.module\.css$/,
              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader', options: {
                  sourceMap: true,
                  modules: true,
                  minimize: !ENV.isDevelopment,
                  localIdentName: '[local]___[hash:base64:5]'
                }
              }, { loader: 'postcss-loader', options: postcssOptions }]
            }, {
              test: function test(filePath) {
                return (/\.less$/.test(filePath) && !/\.module\.less$/.test(filePath)
                );
              },

              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader', options: {
                  sourceMap: true,
                  minimize: !ENV.isDevelopment
                }
              }, { loader: 'postcss-loader', options: postcssOptions }, { loader: 'less-loader', options: { sourceMap: true, modifyVars: theme } }]
            }, {
              test: /\.module\.less$/,
              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader', options: {
                  sourceMap: true,
                  modules: true,
                  minimize: !ENV.isDevelopment,
                  localIdentName: '[local]___[hash:base64:5]'
                }
              }, { loader: 'postcss-loader', options: postcssOptions }, { loader: 'less-loader', options: { sourceMap: true, modifyVars: theme } }]
            }];
            othersRules = [{
              test: /\.woff(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/font-woff' }
              }]
            }, {
              test: /\.woff2(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/font-woff' }
              }]
            }, {
              test: /\.ttf(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/octet-stream' }
              }]
            }, {
              test: /\.eot(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/vnd.ms-fontobject' }
              }]
            }, {
              test: /\.svg(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'image/svg+xml' }
              }]
            }, {
              test: /\.(png|jpg|jpeg|gif)(\?v=\d+\.\d+\.\d+)?$/i,
              use: [{ loader: 'url-loader', options: { limit: limit } }]
            }, {
              test: /\.html?$/,
              use: [{
                loader: 'file-loader', options: {
                  name: '[path][name].[ext]'
                }
              }]
            }, {
              test: /\.hbs?$/, use: [{ loader: 'mustache-loader' }]
            }];
            styleRulesFixed = stylesRules;


            if (ENV.isProduction || ENV.isBeta) {
              styleRulesFixed = stylesRules.map(function (rule) {
                rule.use[0] = _plugins.MiniCssExtractPlugin.loader;
                return rule;
              });
            }

            context.rules = scriptRules.concat(styleRulesFixed).concat(othersRules).concat(rules);

            threadPool = _plugins.HappyPack.ThreadPool({ size: THREAD_POOL_CPU_SIZE });


            plugins.push(new _plugins.HappyPack({
              id: 'jsx',
              threadPool: threadPool,
              loaders: [{ loader: 'babel-loader', options: babelOptions }]
            }));

            plugins.push(new _plugins.HappyPack({
              id: 'tsx',
              threadPool: threadPool,
              loaders: [{ loader: 'babel-loader', options: babelOptions }, { loader: 'ts-loader', options: tsOptions }]
            }));

            plugins.push(new _plugins.ForkTsCheckerWebpackPlugin({
              tsconfig: tsConfigPath,
              checkSyntacticErrors: true,
              colors: true,
              async: true
            }));

            plugins.push(new _plugins.WatchIgnorePlugin([/\.d\.ts$/]));

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];